
    *** MiniStartup by Photon ***

	INCLUDE "PhotonsMiniWrapper1.04!.S"

********** Symbols **********

	INCLUDE "Blitter-Register-List.S"

********** Macros **********

WAITBLIT:MACRO
	tst (a6)			;A1000 blitwait bug fix
.wb\@:	btst #6,DMACONR(a6)
	bne.s .wb\@		;use "bne.s *-4" in incompatible assemblers
	ENDM

SinScale:MACRO				;a5=sine table start
	muls (a5,\1.w),\2
	add.l \2,\2
	swap \2
	ENDM

CosScale:MACRO				;a6=cos table start
	muls (a6,\1.w),\2
	add.l \2,\2
	swap \2
	ENDM

PERSP2D:MACRO			;final projection from world to screen coords
	neg.w d4		;world +z is forward,screen perspective is away
	asr.w #8,d4		;this scaling
	add.w #93,d4		;and eye Z determines Field of View.
	divs d4,d0
	divs d4,d1
	ENDM

********** Demo **********		;Demo-specific non-startup code below.

w	=208				;screen width, height, depth
h	=200
bpls	=4				;handy values:
bpl	=w/16*2				;byte-width of 1 bitplane line
bwid	=bpls*bpl			;byte-width of 1 pixel line (all bpls)

bobh	=40				;height of bob used
MaxBobs	=12				;number of bobs in the vector object

Demo:					;a4=VBR, a6=Custom Registers Base addr
    *--- init ---*
	move.l #VBint,$6c(a4)
	move.w #$c020,$9a(a6)
	move.w #$87c0,$96(a6)
    *--- clear old bob ptrs ---*
	lea LastBobs,a0
	lea LastBobs2,a1
	moveq #MaxBobs-1,d0
.l0:	clr.l (a0)+
	clr.l (a1)+
	dbf d0,.l0
    *--- clear screens ---*
	lea Screen,a1
	bsr.w ClearScreen
	lea Screen2,a1
	bsr.w ClearScreen
	WAITBLIT
    *--- start copper ---*
	lea Screen,a0
	moveq #bpl,d0
	lea BplPtrs+2,a1
	moveq #bpls-1,d1
	bsr.w PokePtrs

	move.l #Copper,$80(a6)

********************  main loop  ********************
MainLoop:
	move.w #$104,d0
	bsr.w WaitRaster
    *--- swap buffers ---*
	movem.l DrawBuffer(PC),a2-a3
	exg a2,a3
	movem.l a2-a3,DrawBuffer	;draw into a2, show a3
    *--- show one... ---*
	move.l a3,a0
	moveq #bpl,d0
	lea BplPtrs+2,a1
	moveq #bpls-1,d1
	bsr.w PokePtrs
    *--- ...draw into the other(a2) ---*

    *--- add angles ---*
	lea axspeed(PC),a0
	lea ax(PC),a1
	move.w #1024*2-2,d3		;keep angles within 0..1023 word offset
	movem.w (a1)+,d0-d2
	add.w (a0)+,d0
	add.w (a0)+,d1
	add.w (a0)+,d2
	and.w d3,d0
	and.w d3,d1
	and.w d3,d2
	movem.w d0-d2,-(a1)

    *--- rotate 3D object ---*

	lea Vertices(PC),a0		;source vertices
	lea Coords(PC),a1		;destination rotated vertices
	moveq #MaxBobs-1,d0
	bsr RotateObj

    *--- sort by Z ---*

	lea Coords+4(PC),a0		;z coord is at offset 4 in "struct"
	lea CoordPtrs(PC),a1
	moveq #MaxBobs-1,d0
	bsr SwaplessReferenceSort

    *--- init for bob blits ---*
	bsr.w WaitBlitter
	move.l #$ffff0000,BLTAFWM(a6)	;mask extra word due to shift
	move.w #bpl-6-2,BLTCMOD(a6)	;C modulo, screen
	move.w #-2,BLTBMOD(a6)		;B modulo, mask
	move.w #-2,BLTAMOD(a6)		;A modulo, bob
	move.w #bpl-6-2,BLTDMOD(a6)	;D modulo, screen
	move.w #bobh*bpls*64+4,d2	;blitsize 40 high x 4 words, used below

    *--- clear bobs ---*		;the old ones left on this screen

	move.l DrawBuffer(PC),a4	;read from...
	lea -MaxBobs*4(a4),a4		;double buffered lastbob screen addr's

	REPT MaxBobs
	WAITBLIT
	move.l #$01000000,BLTCON0(a6)
	move.l (a4)+,BLTDPTH(a6)
	beq.s *+6
	move.w d2,BLTSIZE(a6)
	ENDR

    *--- preset params for DrawBob ---*

	lea Bob,a0
	move.l DrawBuffer(PC),a1
	add.l #(h-bobh)/2*bwid+bpl/2-2,a1     ;center of screen for coord (0,0)
	lea Mask,a2

    *--- draw bobs ---*

	lea CoordPtrs(PC),a5
	lea -MaxBobs*4(a4),a4		;double buffered lastbob screen addr's

	REPT MaxBobs
	move.l (a5)+,a3			;temporary object ptr
	sub.w #$4000,(a3)		;clear "sorted" flag.
	movem.w -4(a3),d0-d1/d4		;read x,y,z
	PERSP2D
	bsr.w DrawBob
	move.l a3,(a4)+			;save bob's screen addr
	ENDR

    *--- main loop end ---*

	btst #6,$bfe001			;Left mouse button not pressed?
	bne.w MainLoop			;then loop

    *--- exit ---*

	rts

********** Demo Routines **********

DrawBob:			;a0-a2=bob/screen/mask, d0-d2=x,y, blit size
    *--- calc shift ---*
	moveq #15,d3
	and.w d0,d3
	add.w d3,d3
	add.w d3,d3
    *--- calc screen addr ---*
	asr.w #4,d0
	add.w d0,d0			;horizontal byte offset
	muls #bwid,d1			;vertical line offset, table possible
	add.w d0,d1
	lea (a1,d1.w),a3
    *--- last:poke only nec. regs ---*
	WAITBLIT
	move.l XtblCookie(PC,d3.w),BLTCON0(a6)	;shifts+minterm
	move.l a3,BLTCPTH(a6)		;C dest
	move.l a0,BLTBPTH(a6)		;B mask (movem.l possible for these 3)
	move.l a2,BLTAPTH(a6)		;A src
	move.l a3,BLTDPTH(a6)		;D dest
	move.w d2,BLTSIZE(a6)		;blit size
	rts				;a3=screen address of bob

XtblCookie:				;look up BLTCON0+1 from X-shift
	dc.l $0fca0000,$1fca1000,$2fca2000,$3fca3000
	dc.l $4fca4000,$5fca5000,$6fca6000,$7fca7000
	dc.l $8fca8000,$9fca9000,$afcaa000,$bfcab000
	dc.l $cfcac000,$dfcad000,$efcae000,$ffcaf000

RotateObj:				;d0/a0-a1=count-1,Vertices,Coords
	MOVEM.L A2-A6,-(SP)
	movem.w ax(PC),a2-a4		;ax,ay,az
	lea Sin(PC),a5
	lea Cos(PC),a6
.vertexl:
	movem.w (a0)+,d1-d3		;x0,y0,z0

    *--- rotation az ---*

	move.w d1,d4			;x1 = x0*cos(az) - y0*sin(az)
	CosScale a4,d4
	move.w d2,d5
	SinScale a4,d5
	sub.w d5,d4			;d4=x1

	move.w d1,d5			;y1 = x0*sin(az) + y0*cos(az)
	SinScale a4,d5
	CosScale a4,d2
	add.w d5,d2			;d2=y1; z1 = z0 = d3 = nop :)

    *--- rotation ax ---*

	move.w d2,d5			;y2 = y1*cos(ax) - z1*sin(ax)
	CosScale a2,d5
	move.w d3,d6
	SinScale a2,d6
	sub.w d6,d5			;d5=y2

	move.w d2,d6			;z2 = y1*sin(ax) + z1*cos(ax)
	SinScale a2,d6
	CosScale a2,d3
	add.w d6,d3			;d3=z2; x2 = x1 = d4 = nop :)

    *--- rotation ay ---*

	move.w d3,d6			;z3 = z2*cos(ay) - x2*sin(ay)
	CosScale a3,d6
	move.w d4,d7
	SinScale a3,d7
	sub.w d7,d6			;d6=z3

	SinScale a3,d3			;x3 = z2*sin(ay) + x2*cos(ay)
	CosScale a3,d4
	add.w d3,d4			;d4=x3; y3 = y2 = d5 = nop :)

;	PERSP2D				;if final stage,save direct screen crds
	move.w d4,(a1)+
	move.w d5,(a1)+
	move.w d6,(a1)+
	dbf d0,.vertexl
	MOVEM.L (SP)+,A2-A6
	RTS

    *--- vector data ---*

max	=4095				;+x,y,z rightward, upward, forward
max2=max*2/3

Vertices:
	dc.w max,max,max		;back surface, counter-clockwise
	dc.w -max,max,max
	dc.w -max,-max,max
	dc.w max,-max,max

	dc.w max2,max2,0		;middle surface, counter-clockwise
	dc.w -max2,max2,0
	dc.w -max2,-max2,0
	dc.w max2,-max2,0

	dc.w max,max,-max		;front surface, counter-clockwise
	dc.w -max,max,-max
	dc.w -max,-max,-max
	dc.w max,-max,-max
VerticesE:

Coords:					;rotated points are written to here.
	ds.b VerticesE-Vertices

CoordPtrs:				;pointers to Z coordinates to be sorted
	dc.l Coords+0*6+4,Coords+1*6+4,Coords+2*6+4,Coords+3*6+4
	dc.l Coords+4*6+4,Coords+5*6+4,Coords+6*6+4,Coords+7*6+4
	dc.l Coords+8*6+4,Coords+9*6+4,Coords+10*6+4,Coords+11*6+4

;Swapless Reference Sort (c) Henrik Erlandsson.
;License and pseudocode at coppershade.org/Swapless-Reference-Sort

SwaplessReferenceSort:			;d0/a0-a1=count-1,Coords+4,CoordPtrs
	move.w d0,d2			;count-1
.sortl:					;outer loop to build output
	move.w d2,d1			;count-1
	move.l a0,a2			;go to start of array
	bra.s .newmin
.scanl:					;inner loop to scan for minimum
	cmp.w (a2),d3			;new minimum value?
	ble.s .nomin
.newmin:move.w (a2),d3			;set minimum
	move.l a2,a3			;and its pointer (reference)
.nomin:	addq.w #6,a2			;next pointer address/"struct in array"
	dbf d1,.scanl

	add.w #$4000,(a3)		;flag value as handled (put above max)
	move.l a3,(a1)+			;minptr stored
	dbf d0,.sortl
	rts

PokePtrs:				;Generic, poke ptrs into copper list
.bpll:	move.l a0,d2
	swap d2
	move.w d2,(a1)			;high word of address
	move.w a0,4(a1)			;low word of address
	addq.w #8,a1			;skip two copper instructions
	add.l d0,a0			;next ptr
	dbf d1,.bpll
	rts

ClearScreen:				;a1=screen destination address to clear
	bsr.w WaitBlitter
	clr.w $66(a6)			;destination modulo
	move.l #$01000000,$40(a6)	;set operation type in BLTCON0/1
	move.l a1,$54(a6)		;destination address
	move.w #h*bpls*64+bpl/2,$58(a6)	;blitter operation size
	rts

VBint:					;Blank template VERTB interrupt
	movem.l d0/a6,-(sp)		;Save used registers
	lea $dff000,a6
	btst #5,$1f(a6)			;check if it's our vertb int.
	beq.s .notvb
    *--- do stuff here ---*
	moveq #$20,d0			;poll irq bit
	move.w d0,$9c(a6)
	move.w d0,$9c(a6)
.notvb:	movem.l (sp)+,d0/a6		;restore
	rte

********** Fastmem Data **********

    *--- double buffering base ptrs ---*

DrawBuffer:	dc.l Screen2
ViewBuffer:	dc.l Screen

axspeed:	dc.w -4*2
ayspeed:	dc.w -5*2
azspeed:	dc.w 3*2
ax:	dc.w 0
ay:	dc.w 0
az:	dc.w 0

Sin:
	INCBIN "SinCos1024w-ampl32767" ;Hybrid (1024+256 words for 360+90 degs)
SinEnd:

Cos	=Sin+((SinEnd-Sin)/5)&$fffffffe		;quarter turn offset

*******************************************************************************
	SECTION ChipData,DATA_C		;declared data that must be in chipmem
*******************************************************************************

Copper:
	dc.w $1fc,0			;Slow fetch mode, remove if AGA demo.
	dc.w $8e,$4481			;200h display window top, left
	dc.w $90,$0cc1			;and bottom, right.
	dc.w $92,$58			;bitplane dma fetch start
	dc.w $94,$b8			;and stop for smaller screen.

	dc.w $108,bwid-bpl		;modulos
	dc.w $10a,bwid-bpl

	dc.w $102,0			;Scroll register (and playfield pri)

Palette:				;sprightly bob colors!
	dc.w $180,$248,$182,$012,$184,$013,$186,$023
	dc.w $188,$025,$18a,$036,$18c,$046,$18e,$058
	dc.w $190,$16a,$192,$001,$194,$48c,$196,$bdf
	dc.w $198,$024,$19a,$136,$19c,$7cf,$19e,$3f3

BplPtrs:
	dc.w $e0,0
	dc.w $e2,0
	dc.w $e4,0
	dc.w $e6,0
	dc.w $e8,0
	dc.w $ea,0
	dc.w $ec,0
	dc.w $ee,0
	dc.w $100,bpls*$1000+$200	;enable bitplanes

	dc.w $ffdf,$fffe		;allow VPOS>$ff

	dc.w $0007,$fffe		;just some stripes. any impression of
	dc.w $180,$313			;"ground" is just imagination. :)
	dc.w $0407,$fffe
	dc.w $180,$434
	dc.w $0c07,$fffe
	dc.w $180,$313
	dc.w $1c07,$fffe
	dc.w $180,$434
	dc.w $ffff,$fffe		;magic value to end copperlist
CopperE:

    *--- graphics ---*

Bob:	INCBIN "blueball.raw"

Mask:	INCBIN "blueballmask.raw"

*******************************************************************************
	SECTION ChipBuffers,BSS_C	;BSS doesn't count toward exe size
*******************************************************************************

    *--- data for buffer 1 ---*
LastBobs:
	ds.l MaxBobs
Screen:	ds.b h*bwid			;Define storage for screen

    *--- data for buffer 2 ---*

LastBobs2:
	ds.l MaxBobs
Screen2:ds.b h*bwid			;two buffers

	END

